# Introduction

## What is an Operating Systems

An Operating System is a special progam responsible for control and administration of a computer. The Operating System load other computer programs, control use of memory, input and output devices, manage the storage and retrieval of data through the file system, etc.

!!! question
    Could you site 4 operating systems?

??? example "Click to show the solution"
    ```
    - Windows
    - Linux
    - Android
    - MacOS X
    - Unix
    ```

## Why Unix?

Why choosing Unix(-like) operating system?

- Stability and Security
- Multiuser and Multitasking
- Networking Capabilities
- **Command-Line Interface (CLI) / Shell**
- Open Standards and Interoperability
- Portability
- **Developer-Friendly Environment**
- Customization and Flexibility

Historically proprietary software developed early 70s at Bell Labs, it has evolved into various flavors and has been a fundamental influence on many modern operating systems.
It exists commercial Unix variants (as University of California, Berkeley (BSD), Oracle (Solaris), etc., and open source versions like OpenSolaris or OpenBSD.

You will most likely use a `Unix-like` operating system instead of Unix in your life. They follow Unix phylosophy but offer other advantages: 

- Diverse Distributions
- Large Community and Package Management
- Wider Hardware Support
- Desktop Environment Choices (e.g. GNOME, KDE on linux)


MacOS X is a Unix-like operating system based on BSD project. 

![](../images/1-intro/MacOSX-Logo-Jaguar-2003.png){: style="height:100px;"}

Linux are open-source Unix-like operating systems that contain the linux kernel (released in 1991 by Linus Torvalds as free software under the GNU General Public License) and supporting system software and libraries, many of which are provided by the GNU Project. 
These operating systems can also be called "GNU/Linux".
GNU stands for "GNU is Not Unix" (the design is Unix-like, but differs from Unix by being free software and containing no Unix code).


![](../images/1-intro/tux.png){: style="height:100px"}
![](../images/1-intro/GNU.png){: style="height:100px"}

!!! question
    Could you site different linux distribution?

??? example "Click to show the solution"
    Few examples are:

        - Ubuntu
        - Fedora
        - Debian
        - CentOS
        - Gentoo
        - Rocky 


## The goal of this course

![](../images/1-intro/GUI.png)
![](../images/1-intro/CLI.png)

Use of the command line to 

* Automate tasks
* be efficient when handling (many/huge) files
* Use of large catalog of (bioinformatic) tools only available in command line.
* Script
* ...

Don't be afraid, no need to lear by heart all commands we will see... google is your friend!

## Terminology

A Command-line interface (CLI), a terminal, a shell, a console...
These terms are often used interchangeably but they have a specific meaning.
Let's start by deciphering there orignal meaning:

### Terminal / Console

In a strict sense, a terminal refers primarily to a physical machine equipped with input/output devices and situated at the endpoint of a computer network. It typically consists of a keyboard and a display (monitor).
A terminal by itself does not offer much functionality. The teletype (`TTY`) was an example of an early-day terminal and predated the use of a computer screen by decades.
These machines worked like a typewriter excepted the letters you typed got send over a serial cable (RS-232) to a Unix computer. Teletype machines got made as a replacement for the telegraph. One cable by terminal!

![](../images/1-intro/tty.webp){: style="height:250px"}

A terminal can be a physical devices (`TTY``) communicating over a RS-232 cable. 

![](../images/1-intro/DEC_VT100_terminal_transparent.png){: style="height:150px;width:150px"}

Or a software-based emulations

![](../images/1-intro/emulated_terminal.png){: style="height:250px"}

* A console

When keyboard and screen replaced the teletypewriter the name of the machine changed into “system console“. So by definition a console is a terminal. The name "Console" comes from the furniture point of view.

![](../images/1-intro/console.jpg){: style="height:250px"}


On Unix, files can represent physical devices like your keyboard, mouse, etc. Those type of files are located into the `/dev` directory. They provide a way to communicate with the device drivers handling communications with the underlying physical device.
As example a program could open the `/dev/tty` file and read from it to get what was being typed on a teletype machine.

### Shell

A terminal by itself does not offer much functionality.
A Unix Terminal is really just a way to pump characters into a `/dev/tty` device and read characters and control characters from the same device. 

To be able to parse user input, interpret that input as commands to run and display results, we need a `Unix Shell`. The Shell manages things like the terminal where you write your commands.

Unix operating systems are described with a metaphore: a nut. 
The nut has 2 layers:
    * The low level layer is the kernel, the useful part of the nut, and well protected behind the shell.
    * The high level layer is the nut’s shell. To access the kernel you must go through the shell.

![](../images/1-intro/nut.png){: style="height:250px"}

The shell gives users (or other programs) a way to get "inside" the system!
Not every shell will have the same syntax. In many ways, you can view programming languages such as Python, Ruby and Julia as shells onto themselves. However, these programming environments are not well suited as Unix shells since files, processes, programs, directories, and pipes are not first-class objects (an entity that can be dynamically created, destroyed, passed to a function, returned as a value,...).
Unix shell like bash are not good as generic programming languages but they are good at the things like file-management and jobs control.

!!! question
    Could you site 2 shells?

??? example "Click to show the solution"
    ```
    - sh
    - bash
    - Cmd (Windows)
    - PowerShell (Windows)
    ```

On the command line, the shell is the program that interprets and processes the commands typed in the terminal. Then, it returns a result to print. A shell operates like an application and can be replaced as needed. 

### Command Line Interface (CLI)

The command line interface is a text-based user interface that allows users to interact with the computer by typing commands that the shell interprets and executes.

When opening a CLI you will get a blank/black screen with a command prompt. 
The command prompt consists of a brief text string followed by a blinking cursor.
Commands are ready to be entered.

![](../images/1-intro/prompt_linux.png){: style="height:400px"}
![](../images/1-intro/prompt_osx.png){: style="height:400px"}

!!! question
    On these pictures, what is the prompt?  
    Where your commands will be entered?

On Unix system as Mac and Linux the CLI is a program called `Terminal`

!!! Exercise
    Open your terminal and look at your prompt.


Your are now ready to write a command and press `enter` to execute it! You can try your first command: 

```bash
echo "coucou"
```
